using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using Microsoft.TeamFoundation.Build.Client;
using Microsoft.TeamFoundation.Build.Workflow.Activities;

namespace Benday.TeamBuild2012.Activities
{
    public abstract class BuildActivityBase : CodeActivity
    {
        public abstract string ActivityName { get; }

        protected void LogDebugVariableValue(CodeActivityContext context, string variableName, bool variableValue)
        {
            string message = String.Format("{0} -- '{1}' = '{2}'", ActivityName, variableName, variableValue);

            context.TrackBuildMessage(message, BuildMessageImportance.Low);
        }

        protected void LogDebugVariableValue(CodeActivityContext context, string variableName, string variableValue)
        {
            string message = String.Format("{0} -- '{1}' = '{2}'", ActivityName, variableName, variableValue);

            context.TrackBuildMessage(message, BuildMessageImportance.Low);
        }

        protected void LogDebugMessage(CodeActivityContext context, string message)
        {
            context.TrackBuildMessage(
                String.Format("{0} -- '{1}'", ActivityName, message),
                BuildMessageImportance.Low);
        }

        protected void LogUsefulMessage(CodeActivityContext context, string message)
        {
            context.TrackBuildMessage(
                String.Format("{0} -- '{1}'", ActivityName, message),
                BuildMessageImportance.High);
        }

        protected void LogException(CodeActivityContext context, Exception ex)
        {
            context.TrackBuildError(
                String.Format("{0} -- An exception occurred.  '{1}'", ActivityName, ex));
        }

        protected string SafeTrim(string value)
        {
            if (value != null)
            {
                return value.Trim();
            }
            else
            {
                return String.Empty;
            }
        }
    }
}
