using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using Microsoft.TeamFoundation.Build.Client;
using Microsoft.TeamFoundation.Build.Workflow.Activities;
using System.IO;

namespace Benday.TeamBuild2012.Activities
{
    public static class MsBuildParameterParser
    {
        public static IDictionary<string, string> Parse(string parameterString)
        {
            IDictionary<string, string> returnValue = new Dictionary<string, string>();

            if (parameterString == null)
            {
                // bail out
            }
            else
            {
                if (parameterString.StartsWith("/p:") == true)
                {
                    parameterString = parameterString.Substring(3);
                }

                var splitBySemiColon = parameterString.Split(new char[] {';'});

                if (splitBySemiColon != null && splitBySemiColon.Length > 0)
                {
                    ProcessParameters(returnValue, splitBySemiColon);
                }
            }            

            return returnValue;
        }

        private static void ProcessParameters(IDictionary<string, string> returnValue, string[] values)
        {
            foreach (var fromValue in values)
            {
                if (fromValue == null || fromValue.Contains("=") == false)
                {
                    continue;
                }
                else
                {
                    var splitByEquals = fromValue.Split(new char[] { '=' });

                    if (splitByEquals.Length == 2)
                    {
                        if (returnValue.ContainsKey(splitByEquals[0]) == false)
                        {
                            returnValue.Add(splitByEquals[0], splitByEquals[1]);
                        }
                    }
                }
            }
        }
    }
}
