using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using Microsoft.TeamFoundation.Build.Client;
using Microsoft.TeamFoundation.Build.Workflow.Activities;
using System.IO;
using System.Threading;

namespace Benday.TeamBuild2012.Activities
{
    [BuildActivity(HostEnvironmentOption.Agent)]
    public sealed class Sleep : BuildActivityBase
    {
        public override string ActivityName
        {
            get { return "Sleep"; }
        }

        [RequiredArgument]
        public InArgument<int> NumberOfMilliseconds { get; set; }

        protected override void Execute(CodeActivityContext context)
        {
            try
            {
                LogDebugMessage(context, "Initializing...");

                int numberOfMillisecs = NumberOfMilliseconds.Get(context);

                LogDebugVariableValue(context, "NumberOfMilliseconds", numberOfMillisecs.ToString());

                LogDebugMessage(context, String.Format("Sleeping for {0} ms.", numberOfMillisecs));

                Thread.Sleep(numberOfMillisecs);

                LogUsefulMessage(context, String.Format("Slept for {0} ms.", numberOfMillisecs));
            }
            catch (Exception ex)
            {
                context.TrackBuildError(
                    String.Format(
                    "Sleep: An exception occurred.  {0}", ex.ToString()));
            }
        }
    }
}
