using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Activities;
using Microsoft.TeamFoundation.Build.Client;
using Microsoft.TeamFoundation.Build.Workflow.Activities;
using System.IO;

namespace Benday.TeamBuild2012.Activities
{
    [BuildActivity(HostEnvironmentOption.Agent)]
    public sealed class TouchFile : BuildActivityBase
    {
        public override string ActivityName
        {
            get { return "TouchFile"; }
        }

        [RequiredArgument]
        public InArgument<string> TargetPath { get; set; }

        protected override void Execute(CodeActivityContext context)
        {
            try
            {
                LogDebugMessage(context, "Initializing...");

                string tempTargetFile = TargetPath.Get(context);

                LogDebugVariableValue(context, "TargetPath", tempTargetFile);

                if (File.Exists(tempTargetFile) == false)
                {
                    throw new FileNotFoundException("Target file does not exist.", tempTargetFile);
                }
                else 
                {
                    File.SetAttributes(tempTargetFile, FileAttributes.Normal);
                    File.SetLastWriteTime(tempTargetFile, DateTime.Now);

                    LogUsefulMessage(context, String.Format("Touched file '{0}'.", tempTargetFile));
                }
            }
            catch (Exception ex)
            {
                LogException(context, ex);
                throw;
            }
        }
    }
}
