using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Benday.TeamBuild2012;
using System.IO;
using System.Activities;

namespace Benday.TeamBuild2012.UnitTests
{
    [TestClass]
    public class SleepFixture : UnitTestBase
    {
        [TestMethod]
        public void SleepFixture_SleepFor5Seconds()
        {
            // Create an instance of our test workflow
            var workflow = new WorkflowForSleep();

            // Create the workflow run-time environment
            var workflowInvoker = new WorkflowInvoker(workflow);

            // New up an instance of our mock BuildDetail object to add to the Workflow
            // environment's extensions
            BuildDetail buildDetailInstance = new BuildDetail();
            workflowInvoker.Extensions.Add(buildDetailInstance);

            Dictionary<string, object> variables = new Dictionary<string, object>();

            variables.Add("NumberOfMilliseconds", 5000);

            DateTime before = DateTime.Now;

            // Invoke the workflow and capture the outputs
            IDictionary<String, Object> outputs = workflowInvoker.Invoke(variables);

            DateTime after = DateTime.Now;

            var duration = after - before;

            Assert.IsTrue(duration.TotalMilliseconds >= 5000, "Execution should have lasted at least 5000ms but was '{0}'.", duration.TotalMilliseconds);
        }
    }
}
